//----------------------------------------------------------------------
//  移動平均
//
//  2023/01/16, Copyright (c) 2023 MIKAMI, Naoki
//----------------------------------------------------------------------

#include "MultirateLiPh.hpp"
#include "MovingAverage.hpp"
#pragma diag_suppress 870   // マルチバイト文字使用の警告抑制のため
using namespace Mikami;

const float FS_ = 10.0f;        // 入力の標本化周波数： 10 kHz
MultirateLiPh myAdDa_(FS_);     // 出力標本化周波数を４倍にするオブジェクト
MovingAverage df_(19);          // 次数：19，平均するデータ数：20

// ADC 変換終了割込みに対する割込みサービス･ルーチン
void AdcIsr()
{
    float xn = myAdDa_.Input(); // 入力
    float yn = df_.Execute(xn); // 移動平均の処理
    myAdDa_.Output(yn);         // 出力
}

int main()
{
    printf("\r\n移動平均を実行します\r\n");

    myAdDa_.Start(&AdcIsr);     // 標本化を開始する
    while (true) {}
}
